<template>
  <q-form
    action="https://some-url.com"
    method="post"
    @submit.prevent="createTodo"
    class="q-pa-md"
  >
    <div class="text-h6">
      {{ save_mode == "new" ? "New Todo" : "Edit Todo" }}

      <q-btn
        v-if="save_mode == 'edit'"
        color="secondary"
        label="New"
        @click="newTodoMode"
        :loading="btn_loading"
        :disable="btn_loading"
      />
    </div>
    <q-input color="green-10" v-model="title" label="Title">
      <template v-slot:prepend>
        <q-icon name="title" />
      </template>
    </q-input>

    <q-input
      color="green-10"
      v-model="description"
      label="Description"
      type="textarea"
      autogrow
    >
      <template v-slot:prepend>
        <q-icon name="description" />
      </template>
    </q-input>

    <div class="q-py-md">
      <q-btn
        color="secondary"
        label="Submit"
        @click="createUpdate"
        :loading="btn_loading"
        :disable="btn_loading"
      />
    </div>
  </q-form>
</template>

<script setup>
import axios from "axios";
import { computed, watch, onMounted, reactive, ref } from "vue";
import { useRoute, useRouter } from "vue-router";

const emit = defineEmits(["close", "unClose"]);
const props = defineProps({
  activeId: String,
});

watch(
  () => props.activeId,
  (first, second) => {
    showUpdateTodoInfo(props.activeId);
  }
);

let btn_loading = ref(false);

const route = useRoute();

let title = ref();
let description = ref();
let save_mode = ref("new");
function newTodoMode() {
  save_mode.value = "new";
  title.value = "";
  description.value = "";
}

// -----------------crud

function createUpdate() {
  btn_loading.value = true;
  let new_update_data = {
    title: title.value,
    description: description.value,
    created: new Date(),
  };

  if (save_mode.value == "new") {
    axios
      .post(
        "https://todolist-965e6-default-rtdb.firebaseio.com/todo.json",
        new_update_data
      )
      .then((response) => {
        emit("getTodoList");
      });
  } else if (save_mode.value == "edit") {
    axios
      .put(
        `https://todolist-965e6-default-rtdb.firebaseio.com/todo/${props.activeId}.json`,
        new_update_data
      )
      .then((response) => {
        emit("getTodoList");
      });
  }

  btn_loading.value = false;
  save_mode.value = "new";
  title.value = "";
  description.value = "";
}

function showUpdateTodoInfo(id) {
  axios
    .get(`https://todolist-965e6-default-rtdb.firebaseio.com/todo/${id}.json`)
    .then((response) => {
      save_mode.value = "edit";

      console.log(response);
      let edit_Todo = response.data;
      title.value = edit_Todo.title;
      description.value = edit_Todo.description;
    });
}

// -----------------crud
</script>
